unit TMSRemoteUnit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Profiles, CyTools, Menus;

type
  TForm3 = class(TForm)
    Button_OK            : TButton;
    Button_ProfileDelete : TButton;
    Button_ProfileNew    : TButton;
    Button_SaveChanges   : TButton;
    CheckBox_TFIRInUse   : TCheckBox;
    ComboBox_PowerOnMode : TComboBox;
    ComboBox_RemoteMode  : TComboBox;
    Edit_ProfileName     : TEdit;
    Edit_TFIRIP          : TEdit;
    Edit_TFIRPort        : TEdit;
    Edit_TFIRRetries     : TEdit;
    Edit_TFIRTimeout     : TEdit;
    Edit_TMSRemotePassword: TEdit;
    Edit_TMSRemoteTimeout: TEdit;
    Edit_ToppyBootRetries: TEdit;
    Edit_ToppyBootTimeout: TEdit;
    Edit_ToppyIP         : TEdit;
    Edit_ToppyPingIP     : TEdit;
    Edit_ToppyPingMAC    : TEdit;
    Edit_ToppyPort       : TEdit;
    Edit_ToppyVFDPort    : TEdit;
    Label1               : TLabel;
    Label10              : TLabel;
    Label11              : TLabel;
    Label12              : TLabel;
    Label13              : TLabel;
    Label15              : TLabel;
    Label17              : TLabel;
    Label18              : TLabel;
    Label19              : TLabel;
    Label2               : TLabel;
    Label3               : TLabel;
    Label4               : TLabel;
    Label5               : TLabel;
    Label6               : TLabel;
    Label7               : TLabel;
    Label8               : TLabel;
    Label9               : TLabel;
    ListBox_Profiles     : TListBox;
    MainMenu1            : TMainMenu;
    Menu_Profiles        : TMenuItem;
    Menu_Profiles_DeleteIni: TMenuItem;
    Menu_Profiles_ExportToIni: TMenuItem;
    Menu_Profiles_ImportFromIni: TMenuItem;
    Panel1               : TPanel;
    Panel_TFIR           : TPanel;
    Panel_TMS            : TPanel;

    procedure FormShow(Sender: TObject);
    procedure Button_ProfileNewClick(Sender: TObject);
    procedure Edit_ProfileNameEnter(Sender: TObject);
    procedure Edit_TFIRIPEnter(Sender: TObject);
    procedure Edit_TFIRPortEnter(Sender: TObject);
    procedure Edit_TFIRTimeoutEnter(Sender: TObject);
    procedure Edit_TFIRRetriesEnter(Sender: TObject);
    procedure Edit_ToppyIPEnter(Sender: TObject);
    procedure Edit_ToppyPortEnter(Sender: TObject);
    procedure Edit_ToppyBootTimeoutEnter(Sender: TObject);
    procedure Edit_ToppyBootRetriesEnter(Sender: TObject);
    procedure Edit_TMSRemoteTimeoutEnter(Sender: TObject);
    procedure CheckBox_TFIRInUseClick(Sender: TObject);
    procedure Button_SaveChangesClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure Button_ProfileDeleteClick(Sender: TObject);
    procedure ListBox_ProfilesClick(Sender: TObject);
    procedure Edit_TMSRemotePasswordChange(Sender: TObject);
    procedure Edit_ToppyVFDPortEnter(Sender: TObject);
    procedure Menu_Profiles_ExportToIniClick(Sender: TObject);
    procedure Menu_Profiles_ImportFromIniClick(Sender: TObject);
    procedure Menu_Profiles_DeleteIniClick(Sender: TObject);
    procedure Edit_ToppyPingMACEnter(Sender: TObject);
    procedure Edit_ToppyPingMACExit(Sender: TObject);

  private
    var
      PwdChanged       : Boolean;

    procedure ShowList();
    procedure ShowDetails();
    procedure UpdateDetails();
    procedure EnableFields();

  public

  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

procedure TForm3.Button_OKClick(Sender: TObject);
begin
  Self.ModalResult := mrOk;
end;

procedure TForm3.Button_ProfileDeleteClick(Sender: TObject);

var
  i, j                 : Integer;
  CP                   : tConnectionProfile;

begin
  if NrConnectionProfiles = 0 then exit;

  if NrConnectionProfiles < 2 then
  begin
    MessageBox(Self.WindowHandle, 'At least one profile is necessary', 'TMSRemote', MB_OK);
    exit;
  end;

  i := ListBox_Profiles.ItemIndex;
  for j := i to NrConnectionProfiles - 2 do
  begin
    ReadConnectionProfile(j + 1, CP);
    WriteConnectionProfile(j, CP);
    ConnectionProfile[j + 1] := ConnectionProfile[j];
  end;
  DeleteConnectionProfile(NrConnectionProfiles - 1);
  dec(NrConnectionProfiles);

  //Reread all connection profiles
  i := 0;
  while True do
  begin
    if not(ReadConnectionProfile(i, ConnectionProfile[i])) then break;
    inc(i);
  end;
  NrConnectionProfiles := i;

  ShowList();
  ListBox_Profiles.ItemIndex := 0;
  EnableFields();
  ShowDetails();
end;

procedure TForm3.Button_ProfileNewClick(Sender: TObject);
begin
  with ConnectionProfile[NrConnectionProfiles] do
  begin
    ProfileName := 'new profile';

    TFIRInUse := false;
    TFIRIP    := '0.0.0.0';
    TFIRPort  := 1414;
    TFIRTimeout := 1;
    TFIRRetries := 3;
    TFIRPingIP  := '0.0.0.0';
    TFIRPingMAC := '00:00:00:00:00:00';

    ToppyIP     := '0.0.0.0';
    ToppyPort   := 1413;
    ToppyVFDPort:= 1415;
    BootTimeout := 45;
    BootRetries := 3;

    TMSRemoteTimeout := 120;
  end;
  inc(NrConnectionProfiles);
  ShowList();
  ListBox_Profiles.ItemIndex := ListBox_Profiles.Items.Count - 1;
  EnableFields();
  ShowDetails();
  Edit_ProfileName.SetFocus();
end;

procedure TForm3.Button_SaveChangesClick(Sender: TObject);

var
  x                    : Integer;

begin
  UpdateDetails();
  x := ListBox_Profiles.ItemIndex;
  WriteConnectionProfile(x, ConnectionProfile[x]);
  ShowList();
  ListBox_Profiles.ItemIndex := x;
  PwdChanged := False;
end;

procedure TForm3.CheckBox_TFIRInUseClick(Sender: TObject);
begin
  Edit_TFIRIP.Enabled          := CheckBox_TFIRInUse.Checked;
  Edit_TFIRPort.Enabled        := CheckBox_TFIRInUse.Checked;
  Edit_TFIRTimeout.Enabled     := CheckBox_TFIRInUse.Checked;
  Edit_TFIRRetries.Enabled     := CheckBox_TFIRInUse.Checked;
  ComboBox_RemoteMode.Enabled  := CheckBox_TFIRInUse.Checked;
  ComboBox_PowerOnMode.Enabled := CheckBox_TFIRInUse.Checked;
  Edit_ToppyPingIP.Enabled     := CheckBox_TFIRInUse.Checked;
  Edit_ToppyPingMAC.Enabled    := CheckBox_TFIRInUse.Checked;
end;

procedure TForm3.Edit_ProfileNameEnter(Sender: TObject);
begin
  Edit_ProfileName.SelectAll();
end;

procedure TForm3.Edit_TFIRIPEnter(Sender: TObject);
begin
  Edit_TFIRIP.SelectAll();
end;

procedure TForm3.Edit_TFIRPortEnter(Sender: TObject);
begin
  Edit_TFIRPort.SelectAll();
end;

procedure TForm3.Edit_TFIRRetriesEnter(Sender: TObject);
begin
  Edit_TFIRRetries.SelectAll();
end;

procedure TForm3.Edit_TFIRTimeoutEnter(Sender: TObject);
begin
  Edit_TFIRTimeout.SelectAll();
end;

procedure TForm3.Edit_TMSRemotePasswordChange(Sender: TObject);
begin
  PwdChanged := True;
end;

procedure TForm3.Edit_TMSRemoteTimeoutEnter(Sender: TObject);
begin
  Edit_TMSRemoteTimeout.SelectAll();
end;

procedure TForm3.Edit_ToppyBootRetriesEnter(Sender: TObject);
begin
  Edit_ToppyBootRetries.SelectAll();
end;

procedure TForm3.Edit_ToppyBootTimeoutEnter(Sender: TObject);
begin
  Edit_ToppyBootTimeout.SelectAll();
end;

procedure TForm3.Edit_ToppyIPEnter(Sender: TObject);
begin
  Edit_ToppyIP.SelectAll();
end;

procedure TForm3.Edit_ToppyPingMACEnter(Sender: TObject);
begin
  Edit_ToppyPingMAC.SelectAll();
end;

procedure TForm3.Edit_ToppyPingMACExit(Sender: TObject);

var
  s                    : String;
  MAC                  : array[0..5] of byte;

begin
  if Edit_ToppyPingMAC.Text = '' then
  begin
    Edit_ToppyPingMAC.Text := '00:00:00:00:00:00';
  end else if (Length(Edit_ToppyPingMAC.Text) <> 17) and (Length(Edit_ToppyPingMAC.Text) <> 12) then
  begin
    MessageBox(Self.WindowHandle, 'Incorrect MAC format', 'TMSRemote', 0);
    Edit_ToppyPingMAC.SetFocus();
  end else
  begin
    s := Edit_ToppyPingMAC.Text;
    if Length(Edit_ToppyPingMAC.Text) <> 17 then
    begin
      insert(':', s, 3);
      insert(':', s, 6);
      insert(':', s, 9);
      insert(':', s, 12);
      insert(':', s, 15);
    end;
    MAC[0] := StrToInt('$' + copy(s,  1, 2));
    MAC[1] := StrToInt('$' + copy(s,  4, 2));
    MAC[2] := StrToInt('$' + copy(s,  7, 2));
    MAC[3] := StrToInt('$' + copy(s, 10, 2));
    MAC[4] := StrToInt('$' + copy(s, 13, 2));
    MAC[5] := StrToInt('$' + copy(s, 16, 2));

    s := format('%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x', [MAC[0], MAC[1], MAC[2], MAC[3], MAC[4], MAC[5]]);
    Edit_ToppyPingMAC.Text := s;
  end;
end;

procedure TForm3.Edit_ToppyPortEnter(Sender: TObject);
begin
  Edit_ToppyPort.SelectAll();
end;

procedure TForm3.Edit_ToppyVFDPortEnter(Sender: TObject);
begin
  Edit_ToppyVFDPort.SelectAll();
end;

procedure TForm3.FormShow(Sender: TObject);
begin
  ComboBox_RemoteMode.Items.Clear();
  ComboBox_RemoteMode.Items.Add('Mode 1 (TF5000 MP)');
  ComboBox_RemoteMode.Items.Add('Mode 2');
  ComboBox_RemoteMode.Items.Add('Mode 3');
  ComboBox_RemoteMode.Items.Add('Mode 4 (TF5000)');
  ComboBox_RemoteMode.Items.Add('Mode 5 (TMS)');

  ComboBox_PowerOnMode.Items.Clear();
  ComboBox_PowerOnMode.Items.Add('Same as normal mode');
  ComboBox_PowerOnMode.Items.Add('Mode 1 (TF5000 MP)');
  ComboBox_PowerOnMode.Items.Add('Mode 2');
  ComboBox_PowerOnMode.Items.Add('Mode 3');
  ComboBox_PowerOnMode.Items.Add('Mode 4 (TF5000)');
  ComboBox_PowerOnMode.Items.Add('Mode 5 (TMS)');

  ShowList();
  EnableFields();
  if NrConnectionProfiles > 0 then
  begin
    ListBox_Profiles.ItemIndex := 0;
    ShowDetails();
  end;
  PwdChanged := False
end;

procedure TForm3.ListBox_ProfilesClick(Sender: TObject);
begin
  ShowDetails();
end;

procedure TForm3.Menu_Profiles_DeleteIniClick(Sender: TObject);
begin
  DeleteConnectionProfileINIFile();
end;

procedure TForm3.Menu_Profiles_ExportToIniClick(Sender: TObject);

var
  i                    : Integer;

begin
  for i := 0 to NrConnectionProfiles - 1 do
    WriteConnectionProfileINI(i, ConnectionProfile[i]);
end;

procedure TForm3.Menu_Profiles_ImportFromIniClick(Sender: TObject);

var
  i                    : Integer;

begin
  for i := 0 to NrConnectionProfiles - 1 do
    WriteConnectionProfileREG(i, ConnectionProfile[i]);
end;

procedure tForm3.ShowList();

var
  i                    : Integer;

begin
  ListBox_Profiles.Items.Clear();
  for i := 0 to NrConnectionProfiles - 1 do
    ListBox_Profiles.Items.Add(ConnectionProfile[i].ProfileName);
end;

procedure tForm3.ShowDetails();

var
  CPIndex              : Integer;

begin
  CPIndex := ListBox_Profiles.ItemIndex;
  with ConnectionProfile[CPIndex] do
  begin
    Edit_ProfileName.Text       := ProfileName;

    CheckBox_TFIRInUse.Checked  := TFIRInUse;
    Edit_TFIRIP.Text            := TFIRIP;
    Edit_TFIRPort.Text          := Format('%d', [TFIRPort]);
    Edit_TFIRTimeout.Text       := Format('%d', [TFIRTimeout]);
    Edit_TFIRRetries.Text       := Format('%d', [TFIRRetries]);
    if TFIRRemoteMode = 0 then TFIRRemoteMode := 5;
    ComboBox_RemoteMode.ItemIndex := TFIRRemoteMode - 1;
    ComboBox_PowerOnMode.ItemIndex := TFIRPowerOnMode;

    Edit_TFIRIP.Enabled         := TFIRInUse;
    Edit_TFIRPort.Enabled       := TFIRInUse;
    Edit_TFIRTimeout.Enabled    := TFIRInUse;
    Edit_TFIRRetries.Enabled    := TFIRInUse;
    ComboBox_RemoteMode.Enabled := TFIRInUse;
    Edit_ToppyPingIP.Enabled    := TFIRInUse;
    Edit_ToppyPingMAC.Enabled   := TFIRInUse;
    Edit_ToppyPingIP.Text       := TFIRPingIP;
    Edit_ToppyPingMAC.Text      := TFIRPingMAC;

    Edit_ToppyIP.Text           := ToppyIP;
    Edit_ToppyPort.Text         := Format('%d', [ToppyPort]);
    Edit_ToppyVFDPort.Text      := Format('%d', [ToppyVFDPort]);

    Edit_ToppyBootTimeout.Text  := Format('%d', [BootTimeout]);
    Edit_ToppyBootRetries.Text  := Format('%d', [BootRetries]);

    Edit_TMSRemoteTimeout.Text  := Format('%d', [TMSRemoteTimeout]);

    if PwdHash <> 0  then
      Edit_TMSRemotePassword.Text := format('%d', [PwdHash])
    else
      Edit_TMSRemotePassword.Text := '';
  end;
end;

procedure tForm3.UpdateDetails();

var
  CPIndex              : Integer;
  Pwd                  : array[0..50] of AnsiChar;

begin
  CPIndex := ListBox_Profiles.ItemIndex;
  with ConnectionProfile[CPIndex] do
  begin
    ProfileName := Edit_ProfileName.Text;

    TFIRInUse := CheckBox_TFIRInUse.Checked;
    TFIRIP := Edit_TFIRIP.Text;
    TFIRPort := StrToIntDef(Edit_TFIRPort.Text, 1414);
    TFIRTimeout := StrToIntDef(Edit_TFIRTimeout.Text, 1);
    TFIRRetries := StrToIntDef(Edit_TFIRRetries.Text, 3);
    TFIRRemoteMode := ComboBox_RemoteMode.ItemIndex + 1;
    TFIRPowerOnMode := ComboBox_PowerOnMode.ItemIndex;
    TFIRPingIP := Edit_ToppyPingIP.Text;
    TFIRPingMAC := Edit_ToppyPingMAC.Text;

    ToppyIP := Edit_ToppyIP.Text;
    ToppyPort := StrToIntDef(Edit_ToppyPort.Text, 1413);
    ToppyVFDPort := StrToIntDef(Edit_ToppyVFDPort.Text, 1415);

    BootTimeout := StrToIntDef(Edit_ToppyBootTimeout.Text, 20);
    BootRetries := StrToIntDef(Edit_ToppyBootRetries.Text, 3);

    TMSRemoteTimeout := StrToIntDef(Edit_TMSRemoteTimeout.Text, 20);

    if PwdChanged then
    begin
      PwdHash := 0;
      if Edit_TMSRemotePassword.Text <> '' then
      begin
        CRC32InitializeTable($04C11DB7);
        StrPCopy(Pwd, Edit_TMSRemotePassword.Text);
        PwdHash := CRC32($ffffffff, @Pwd[0], StrLen(Pwd));
        Edit_TMSRemotePassword.Text := format('%d', [PwdHash]);
      end;
    end;
  end;
end;

procedure tForm3.EnableFields();

var
  e                    : Boolean;

begin
  e := NrConnectionProfiles > 0;
  Edit_ProfileName.Enabled := e;
  Edit_ToppyIP.Enabled := e;
  Edit_ToppyPort.Enabled := e;
  Edit_TFIRIP.Enabled := e;
  Edit_TFIRPort.Enabled := e;
  Edit_TFIRTimeout.Enabled := e;
  Edit_TFIRRetries.Enabled := e;
  Edit_ToppyBootTimeout.Enabled := e;
  Edit_ToppyBootRetries.Enabled := e;
  Edit_TMSRemoteTimeout.Enabled := e;
  Edit_TMSRemotePassword.Enabled := e;
  CheckBox_TFIRInUse.Enabled := e;
  ComboBox_RemoteMode.Enabled := e;
  Button_SaveChanges.Enabled := e;
  Edit_ToppyPingIP.Enabled := e;
  Edit_ToppyPingMAC.Enabled := e;

  Button_ProfileDelete.Enabled := NrConnectionProfiles > 1;
end;

end.

