#ifndef __TMSREMOTENETWORKH__
#define __TMSREMOTENETWORKH__

#include                "tap.h"

#define NETWORKPORT     1413
#define XMTBUFFERSIZE   2048
#define RCVBUFFERSIZE   524288
#define ALIVETIMEOUT    1000
#define HIGHSPEEDUPDATETIMEOUT  500

typedef enum
{
  Cmd_Alive,
  Cmd_Authenticate,
  Cmd_RefreshAll,
  Cmd_KeyEvent,
  Cmd_HideOsd,
  Cmd_Reboot,
  Cmd_VideoFrame,
  Cmd_ASCIIEvent,
  Cmd_WsClose,
  Cmd_WsConnect = 'G'	// WebSocket handshake: "GET /tmsremote HTTP/1.1"
} tCommands;

typedef struct
{
  dword                 cmd;
} tCmd_Alive;

typedef struct
{
  dword                 cmd;
  dword                 CRC32;
} tCmd_Authenticate;

typedef struct
{
  dword                 cmd;
} tCmd_RefreshAll;

typedef struct
{
  dword                 cmd;
  dword                 Key;
} tCmd_KeyEvent;

typedef struct
{
  dword                 cmd;
  dword                 HideOsd;  //0=no, 1=yes
} tCmd_HideOsd;

typedef struct
{
  dword                 cmd;
} tCmd_Reboot;

typedef struct
{
  dword                 cmd;
} tCmd_VideoFrame;

typedef struct
{
  dword                 cmd;
  dword                 ASCIICode;
} tCmd_ASCIIEvent;

typedef struct
{
  dword                 cmd;
} tCmd_WsClose;

typedef enum
{
  MID_RecordingDialog,
  MID_AuthFailed,
  MID_DirectOn,
  MID_DirectOff,
  MID_OSDframeComplete
} tMessageIDs;


dword Network_EventHandler(word event, dword param1, dword param2);
bool  Network_IsAnyConnection(void);
bool  Network_IsOsdHidden(void);
void  Network_Close(void);
bool  SendSocket(byte *Buffer, int BufferLen);
void  SendMessage(dword MessageID);
void  Network_SendDirectOn(void);
void  Network_SendDirectOff(void);

#endif
