/*
 * websocket.h
 *
 *  Created on: 12.09.2013
 *      Author: jkIT
 */

#ifndef WEBSOCKET_H_
#define WEBSOCKET_H_

// WebSocket frame types
typedef enum {
	wsft_continuation,
	wsft_text,
	wsft_binary,
	wsft_reserved3,
	wsft_reserved4,
	wsft_reserved5,
	wsft_reserved6,
	wsft_reserved7,
	wsft_close,
	wsft_ping,
	wsft_pong
} tWebSocketFrameType;

// WebSocket frame mode: masked, unmasked
typedef enum {
	ws_unmasked,
	ws_masked = 128
} tWebSocketMask;

// data storage for relevantHTTP header data
typedef struct {
	int 				ws_version;
	char				host[256];
	char				origin[256];
	char				sec_key[32];
	char				sec_accept[32];
	char				protocol[256];
	char				response[1024];
} tRequestHeader;

// parse HTTP header (connection request)
int ws_parse_header(char *s, int maxlen, tRequestHeader *header);

// decodes a WebSocket frame
unsigned long ws_decode_frame(unsigned char *frame, unsigned char *payload);

// creates a websocket frame header (without mask)
unsigned long ws_create_frame_header(unsigned long len, unsigned char *frame, unsigned char opcode, unsigned char masked);

// encodes a payload to a websocket frame
unsigned long ws_encode_frame(unsigned char *payload, unsigned long len, unsigned char *frame, unsigned char opcode, int masked);

#endif /* WEBSOCKET_H_ */
