/*
 * jk-test.h
 *
 *  Created on: 16.09.2013
 *      Author: jkIT
 */

#ifndef JK_TEST_H_
#define JK_TEST_H_

#define FALSE   0
#define TRUE    1


#define TEST_INIT 	int tests = 0; int passed = 0;

#define TEST_RESULT	printf(	"\npassed %d tests of %d: [%s]\n" , passed, tests, ( passed == tests )	? "ok" : "FAILED");

#define TEST_EXEC(test) printf("\n%s:\n", #test);	passed += test; tests++; printf("\n");


#define TEST_PRINT_ASSERT_RESULT(result, actual) { \
	printf("%-10s\n", result ? "[ok]" : "[FAILED]"); \
	if ( !result ) { printf(" (actual: %d)\n", (int) actual); return FALSE; } \
}

#define TEST_PRINT_ASSERT_STR_RESULT(result, actual) { \
	printf("%-10s\n", result ? "[ok]" : "[FAILED]"); \
	if ( !result ) { printf(" (actual: %s)\n", actual); return FALSE; } \
}



#define TEST_ASSERT_EQ(caption, expected, actual) { \
	printf("%20s == %-30d ", caption, expected); \
	int result = (actual) == (expected); \
	TEST_PRINT_ASSERT_RESULT(result, actual) \
}

#define TEST_ASSERT_GT(caption, expected, actual) { \
	printf("%20s >  %-30d ", caption, expected); \
	int result = (actual) > (expected); \
	TEST_PRINT_ASSERT_RESULT(result, actual) \
}

#define TEST_ASSERT_GE(caption, expected, actual) { \
	printf("%20s >= %-30d ", caption, expected); \
	int result = (actual) >= (expected); \
	TEST_PRINT_ASSERT_RESULT(result, actual) \
}

#define TEST_ASSERT_STR_EQ(caption, expected, actual) { \
	printf("%20s == %-30s ", caption, expected); \
	int result = strcmp(actual, expected) == 0; \
	TEST_PRINT_ASSERT_STR_RESULT(result, actual) \
}


#endif /* JK_TEST_H_ */
